#pragma once

#include "BmsHeader.hpp"
#include "BmsMaterial.hpp"
#include "BmsSequence.hpp"

namespace Lmt {
namespace Max2Bms {
	class BmsGenerator {
	public:
		BmsGenerator( void );
		~BmsGenerator( void );
		BmsHeader * GetHeader( void );
		BmsMaterial * GetMaterial( void );
		BmsSequence * GetSequence( void );
		int GetLineCount( void ) const;
		wstring GetLine( int index ) const;
		void Clear( void );
		void Generate( void );
	private:
		void BuildHeaderScript( list<wstring> &lines );
		void BuildMaterialScript( list<wstring> &lines );
		void BuildSequenceScript( list<wstring> &lines );
	private:
		typedef vector<wstring>  BmsLineArray;
	private:
		BmsHeader m_header;
		BmsMaterial m_material;
		BmsSequence m_sequence;
		BmsLineArray m_lines;
	};
}
}
