#pragma once

namespace Lmt {
namespace Max2Bms {
	class SongDatabase {
	public:
		SongDatabase( void );
		~SongDatabase( void );
		wstring GetHash( void ) const;
		int GetIdentifier( void ) const;
		wstring GetGenre( void ) const;
		wstring GetTitle( void ) const;
		wstring GetArtist( void ) const;
		int GetTempo( void ) const;
		int GetKeyCount( void ) const;
		wstring GetDifficultyName( void ) const;
		int GetDifficulty( void ) const;
		void Clear( void );
		bool Load( const wstring &path );
		bool Select( const wstring &hash );
	private:
		struct SongItem {
			wstring hash;
			int identifier;
			wstring genre;
			wstring title;
			wstring artist;
			int tempo;
			int keyCount;
			wstring difficultyName;
			int difficulty;
		};
	private:
		typedef vector<SongItem>  SongItemArray;
		typedef map<wstring, int>  IndexMap;
		SongItemArray m_items;
		IndexMap m_indexMap;
		int m_index;
	};
}
}
